<?php

include("openssl_enc_dec.php");
if (isset($_REQUEST["cfg"])) {
    $sql_details = unserialize(urldecode(encrypt_decrypt('decrypt', $_REQUEST['cfg'])));
}
include("../dt/Editor/lib/DataTables.php");

date_default_timezone_set('Europe/Bratislava');

use
	DataTables\Editor,
	DataTables\Editor\Field,
	DataTables\Editor\Format,
	DataTables\Editor\Mjoin,
	DataTables\Editor\Options,
	DataTables\Editor\Upload,
	DataTables\Editor\Validate,
	DataTables\Editor\ValidateOptions;

$pohlad = (isset($_POST['pohlad']) && is_numeric($_POST['pohlad'])) ? $_POST['pohlad'] + 0 : 0;

$editor = Editor::inst($db, 'inventura', 'id')
	->fields(
	    Field::inst('inventura.id')->set(false),
	    Field::inst('inventura.kod')->set(false),
	    Field::inst('majetok.nazov')->set(false),
	    Field::inst('majetok.kod_os')->set(false),
	    Field::inst('org_str.nazov')->set(false),
	    Field::inst('majetok.kod_eo')->set(false),
	    Field::inst('ekon_obj.nazov')->set(false),
	    Field::inst('majetok.kod_lok')
            ->set(false)
            ->options(Options::inst()
                ->add('-', '')
                ->table('lokacie')
                ->value('kod')
                ->label('nazov')
                ->order('nazov')
            ),
	    Field::inst('lok_inv.nazov')->set(false),
	    Field::inst('lok_maj.nazov')->set(false),
	    Field::inst('majetok.kod_osoby')->set(false),
	    Field::inst('osoby.meno')->set(false),
	    Field::inst('majetok.vp1')->set(false),
	    Field::inst('majetok.vp2')->set(false),
	    Field::inst('majetok.vp3')->set(false),
	    Field::inst('majetok.datum_zarad')
	    ->set(false)
	    ->getFormatter(function ($val) {
	        if ($val != "0000-00-00") {
	            $date = new DateTime($val);
	            return date_format($date, 'd.m.Y');
	        } else {
	            return null;
	        }
	    }),
	    Field::inst('majetok.cena')
	    ->set(false)
	    -> getFormatter(function ($val) {
	        return str_replace('.', ',', $val);
	    })
	    -> setFormatter(function ($val) {
	        return str_replace(',', '.', $val);
	    }),
	    Field::inst('majetok.mnozstvo')
	    -> getFormatter(function ($val) {
	        return str_replace('.', ',', $val);
	    })
	    -> setFormatter(function ($val) {
	        return str_replace(',', '.', $val);
	    })
	    ->validator(Validate::numeric(',', ValidateOptions::inst()
	        ->message('Neplatná číselná hodnota')
	        )),
	    Field::inst('inventura.mnozstvo')
	    -> getFormatter(function ($val) {
	        return str_replace('.', ',', $val);
	    })
	    -> setFormatter(function ($val) {
	        return str_replace(',', '.', $val);
	    })
	    ->validator(Validate::numeric(',', ValidateOptions::inst()
	        ->message('Neplatná číselná hodnota')
        )),
		Field::inst('majetok.novy')->set(false),
		Field::inst('inventura.kod_lok')
		->options(Options::inst()
		    ->add('-', '')
		    ->table('lokacie')
		    ->value('kod')
		    ->label('nazov')
		    ->order('nazov')
		    ),
	    Field::inst('inventura.poznamka'),
	    Field::inst('inventura.vyradit'),
		Field::inst('inventura.identifikacia'),
		Field::inst('inventura.kod_uziv'),
		Field::inst('inventura.datum')
        ->set(false)
        ->getFormatter(function ($val) {
            if ($val != "0000-00-00 00:00:00") {
                $date = new DateTime($val);
                return date_format($date, 'd.m.Y H:i');
            } else {
                return null;
            }
        }),
		Field::inst('uzivatelia.meno')
		)
	->leftJoin('majetok', 'majetok.kod', '=', 'inventura.kod')
	->leftJoin('org_str', 'org_str.kod', '=', 'majetok.kod_os')
	->leftJoin('ekon_obj', 'ekon_obj.kod', '=', 'majetok.kod_eo')
	->leftJoin('lokacie as lok_maj', 'lok_maj.kod', '=', 'majetok.kod_lok')
	->leftJoin('lokacie as lok_inv', 'lok_inv.kod', '=', 'inventura.kod_lok')
	->leftJoin('osoby', 'osoby.kod', '=', 'majetok.kod_osoby')
	->leftJoin('uzivatelia', 'uzivatelia.kod', '=', 'inventura.kod_uziv')
    ->on('postGet', function ( $editor, &$data, $id ) use ($db) {
        //file_put_contents('log', "data: ".print_r($data, true) . "\n", FILE_APPEND);
		for($i = 0; $i < count($data); ++$i) {
			//file_put_contents('log', "data: ".print_r($data[$i], true) . "\n", FILE_APPEND);
			$sql = "select f.id, f.system_path, f.web_path, f.typ"
				. " from inventura i"
				. " inner join majetok m on (m.kod=i.kod)"
				. " inner join majetok_file on (majetok_file.majetok_id=m.id)"
				. " inner join files f on (f.id=majetok_file.file_id)"
				. " where i.id=:id";
			$res = $db->raw()
				->bind(':id', $data[$i]['inventura']['id'])
				->exec($sql);
			$j = 0;	
			while ($row = $res->fetch(PDO::FETCH_ASSOC)) {
				//file_put_contents('log', "row: ".print_r($row, true) . "\n", FILE_APPEND);
				if ($row['id']) {
					$data[$i]['files'][$j]['id'] = $row['id'];
					$data[$i]['files'][$j]['web_path'] = $row['web_path'];
					$data[$i]['files'][$j]['system_path'] = $row['system_path'];
					$data[$i]['files'][$j]['typ'] = $row['typ'];
				}
				$j = $j + 1;
			}
		}
    })
	->on('postRemove', function ($editor, $id, $values) { 
	    global $db;
	    // zmaz novy majetok, ktory nebol potvrdeny inventurou
	    $kod = $values["inventura"]["kod"];
	    $sql = "delete from majetok where (kod='$kod') and (novy=1)";
	    $db->sql($sql);
	});

//$editor->where('majetok.cena', 16.6, '>');
switch ($pohlad) {
    case 1:
        $editor->where('majetok.novy', 1);
        break;
    case 2:     
        $editor->where('inventura.vyradit', 1);
        break;
    case 3:
        $editor->where( function ( $q ) {
            $q->where('inventura.mnozstvo', 'majetok.mnozstvo', '!=', false);
        });
        break;
    case 4:
        $editor->where( function ( $q ) {
            $q->where('inventura.kod_lok', 'majetok.kod_lok', '!=', false);
        });
}

if (!isset($_POST['action'])) {
    // filtrovanie < > =
    foreach ($_POST["columns"] as &$column) {
        if ($column["search"]["value"] != "") {
            $value = $column["search"]["value"];
            $operator = "";
            if (($value[0] == ">") || ($value[0] == "<") || ($value[0] == "=")) {
                $operator = $value[0];
            }
            if ((substr($value, 0, 2) == ">=") || (substr($value, 0, 2) == "<=") || (substr($value, 0, 2) == "<>")) {
                $operator = substr($value, 0, 2);
            }
            $value = str_replace($operator, "", $value);
            $value = stripslashes($value);
          
            if (strpos($column["data"], 'datum') !== false) {
                // je to datum, uprav vyraz do spravneho formatu
                // konvertuj filtracny vyraz z DD.MM.YYYY na YYYY-MM-DD
                $d = DateTime::createFromFormat('d.m.Y', $value);
                if ($d && $d->format('d.m.Y') == $value) { // test ci je to ozaj datum
                    $value = $d->format('Y-m-d'); // konverzia do YYYY-MM-DD
                } else {
                    if (($value == '00.00.0000') || ($value == '00')) {
                        $value = "0000-00-00";
                    } else {
                        $value = "";
                    }
                }
                if (($value != "") && ($operator == "")) {
                    $operator = "=";
                }
            }
            
            if ($operator != "") {
                if ($value != "") {
                    $editor->where($column["data"], $value, $operator, false);
                    //file_put_contents('log', 'operator: '.print_r($operator, true)."\n", FILE_APPEND);
                    //file_put_contents('log', 'value: '.print_r($value, true)."\n", FILE_APPEND);
                }
                // dalej nefiltruj v metode process
                $column["search"]["value"] = "";
            }
        }
    }
}

$out = $editor
->process($_POST)
->data();
/*
if (!isset($_POST['action'])) {
    foreach ($out["data"] as &$value) {
        $value['inventura']['xxx'] = 'zxcv';
    }
}
*/
echo json_encode($out);

?>